using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;

namespace Luski.Shared.PublicServers.V1.ClientToServer.HTTP;

public class KeyPostCTS : CTS
{
    [JsonInclude]
    [JsonPropertyName("encryption_type")]
    public EncryptionType EncryptionType { get; set; }
    [JsonInclude]
    [JsonPropertyName("key_data")]
    public string Data { get; set; } = string.Empty;
}

[JsonSerializable(typeof(KeyPostCTS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class KeyPostCTSContext : JsonSerializerContext;