using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;

namespace Luski.Shared.PublicServers.V1.ClientToServer.HTTP;

public class MessageCTS : CTS
{
    [JsonInclude]
    [JsonPropertyName("author_id")]
    public long? Profile { get; set; }
    [JsonInclude]
    [JsonPropertyName("channel_id")]
    public long ChannelID { get; set; }
    [JsonInclude]
    [JsonPropertyName("context")]
    public string Base64Context { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("files")]
    public long[] Files { get; set; } = Array.Empty<long>();
    [JsonInclude]
    [JsonPropertyName("encryption_key")]
    public long EncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("encoding")]
    public EncoderType Encoding { get; set; }
}

[JsonSerializable(typeof(MessageCTS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class MessageCTSContext : JsonSerializerContext;