using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ClientToServer.HTTP;

public class RoleMembersPatchCTS : CTS
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("removed_members")]
    public long[] RemovedMembers { get; set; }
    [JsonInclude]
    [JsonPropertyName("added_members")]
    public long[] AddedMembers { get; set; }
}

[JsonSerializable(typeof(RoleMembersPatchCTS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class RoleMembersPatchCTSContext : JsonSerializerContext;