using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.Shared;

namespace Luski.Shared.PublicServers.V1.ClientToServer.HTTP;

public class RoleOverrideCTS : CTS
{
    [JsonInclude]
    [JsonPropertyName("role_id")]
    public long RoleID { get; set; }
    [JsonInclude]
    [JsonPropertyName("good_permissions")]
    public ServerPermission GoodPermissions { get; set; }
    [JsonInclude]
    [JsonPropertyName("bad_permissions")]
    public ServerPermission BadPermissions { get; set; }
}

[JsonSerializable(typeof(RoleOverrideCTS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class RoleOverrideCTSContext : JsonSerializerContext;