using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.Shared;

namespace Luski.Shared.PublicServers.V1.ClientToServer.HTTP;

public class UserOverrideCTS : CTS
{
    [JsonInclude]
    [JsonPropertyName("user_id")]
    public long UserID { get; set; }
    [JsonInclude]
    [JsonPropertyName("good_permissions")]
    public ServerPermission GoodPermissions { get; set; }
    [JsonInclude]
    [JsonPropertyName("bad_permissions")]
    public ServerPermission BadPermissions { get; set; }
}

[JsonSerializable(typeof(UserOverrideCTS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class UserOverrideCTSContext : JsonSerializerContext;