using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class CategorySTC : STC
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("picture_type")]
    public PictureType PictureType { get; set; }
    [JsonInclude]
    [JsonPropertyName("color_type")]
    public ColorType ColorType { get; set; } = ColorType.Full;
    [JsonInclude]
    [JsonPropertyName("color")]
    public string Color { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("name")]
    public string Name { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("description")]
    public string Description { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("parent")]
    public long Parent { get; set; }
    [JsonInclude]
    [JsonPropertyName("inner_categories")]
    public long[] InnerCategories { get; set; } = Array.Empty<long>();
    [JsonInclude]
    [JsonPropertyName("channels")]
    public long[] Channels { get; set; } = Array.Empty<long>();
    [JsonInclude]
    [JsonPropertyName("role_overrides")]
    public RoleOverrideSTC[] RoleOverrides { get; set; } = Array.Empty<RoleOverrideSTC>();
    [JsonInclude]
    [JsonPropertyName("member_overrides")]
    public UserOverrideSTC[] UserOverrides { get; set; } = Array.Empty<UserOverrideSTC>();
    [JsonInclude]
    [JsonPropertyName("title_encryption_key")]
    public long TitleEncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("description_encryption_key")]
    public long DescriptionEncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("title_encoder_type")]
    public EncoderType TitleEncoderType { get; set; }
    [JsonInclude]
    [JsonPropertyName("description_encoder_type")]
    public EncoderType DescriptionEncoderType { get; set; }
}

[JsonSerializable(typeof(CategorySTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class CategorySTCContext : JsonSerializerContext;