using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class KeyGetSTC : STC
{
    
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("owner")]
    public long Owner { get; set; }
    [JsonInclude]
    [JsonPropertyName("encryption_type")]
    public EncryptionType EncryptionType { get; set; }
    [JsonInclude]
    [JsonPropertyName("key_data")]
    public string Data { get; set; } = string.Empty;
}

[JsonSerializable(typeof(KeyGetSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class KeyGetSTCContext : JsonSerializerContext;
