using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class ProfileListSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("profiles")]
    public List<ProfileSTC> Profiles { get; set; } = default!;
}

[JsonSerializable(typeof(ProfileListSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class ProfileListSTCContext : JsonSerializerContext;