using System.ComponentModel;
using System.Net;
using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

[Browsable(false)]
[EditorBrowsable(EditorBrowsableState.Never)]
public class STC
{
    [JsonPropertyName("error")]
    [JsonInclude]
    public ErrorCode? Error { get; set; }
    [JsonIgnore]
    public HttpStatusCode StatusCode { get; init; } = HttpStatusCode.OK;
    [JsonPropertyName("error_message")]
    [JsonInclude]
    public string? ErrorMessage { get; set; }
}

[JsonSerializable(typeof(STC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class STCContext : JsonSerializerContext;