using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class ServerFileInfoSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("name")]
    public string Name { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("encoder_type")]
    public EncoderType Encoder { get; set; }
    [JsonInclude]
    [JsonPropertyName("name_encoder_type")]
    public EncoderType NameEncoder { get; set; }
    [JsonInclude]
    [JsonPropertyName("encryption_key")]
    public long Key { get; set; }
    [JsonInclude]
    [JsonPropertyName("name_encryption_key")]
    public long NameKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("size")]
    public long Size { get; set; }
}

[JsonSerializable(typeof(ServerFileInfoSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class ServerFileInfoSTCContext : JsonSerializerContext;