using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.Shared;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class ServerInfoSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("name")]
    public string Name { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("wssv4")]
    public string WSSv4Address { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("description")]
    public string Description { get; set; } = string.Empty;
    [JsonInclude]
    [JsonPropertyName("owner")]
    public long Owner { get; set; }
    [JsonInclude]
    [JsonPropertyName("picture_type")]
    public PictureType PictureType { get; set; }
    [JsonInclude]
    [JsonPropertyName("alternate_servers")]
    public ServerData[] AlternateServers { get; set; } =Array.Empty<ServerData>();
}

[JsonSerializable(typeof(ServerInfoSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class ServerInfoSTCContext : JsonSerializerContext;