using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

public class SocketUserSTC : STC
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("server_profile")]
    public long ServerProfile { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("selected_channel")]
    public long SelectedChannel { get; set; }
    [JsonInclude]
    [JsonPropertyName("status")]
    public UserStatus Status { get; set; }
    [JsonInclude] 
    [JsonPropertyName("roles")]
    public long[] RoleIds { get; set; } = default!;
}

[JsonSerializable(typeof(SocketUserSTC))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
public partial class SocketUserSTCContext : JsonSerializerContext;