using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

namespace Luski.Shared.PublicServers.V1.Shared;

public class MessageEvent : IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("author_id")]
    public long AuthorID { get; set; }
    [JsonInclude]
    [JsonPropertyName("profile_id")]
    public long ProfileID { get; set; }
    [JsonInclude]
    [JsonPropertyName("channel_id")]
    public long ChannelID { get; set; }
    [JsonInclude]
    [JsonPropertyName("timestamp")]
    public long Timestamp { get; set; }
    [JsonInclude]
    [JsonPropertyName("context")]
    public string Base64Context { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("files")]
    public ServerFileInfoSTC[] Files { get; set; } = Array.Empty<ServerFileInfoSTC>();
    [JsonInclude]
    [JsonPropertyName("encryption_key")]
    public long EncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("encoder_type")]
    public EncoderType EncoderType { get; set; }
}

[JsonSerializable(typeof(MessageEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class MessageEventContext : JsonSerializerContext;