using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

namespace Luski.Shared.PublicServers.V1.Shared;

public class RoleEvent : IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("display_name")]
    public string? DisplayName { get; set; }
    [JsonInclude]
    [JsonPropertyName("index")]
    public int? Index { get; set; }
    [JsonInclude]
    [JsonPropertyName("color_type")]
    public ColorType? ColorType { get; set; }
    [JsonInclude]
    [JsonPropertyName("color")]
    public string? Color { get; set; }
    [JsonInclude]
    [JsonPropertyName("description")]
    public string? Description { get; set; }
    [JsonInclude]
    [JsonPropertyName("server_permissions")]
    public ServerPermission? ServerPermissions { get; set; }
}

[JsonSerializable(typeof(RoleEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class RoleEventContext : JsonSerializerContext;