using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

namespace Luski.Shared.PublicServers.V1.Shared;

public class RoleMemberEvent : IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("removed_members")]
    public long[] RemovedMembers { get; set; }
    [JsonInclude]
    [JsonPropertyName("added_members")]
    public long[] AddedMembers { get; set; }
}

[JsonSerializable(typeof(RoleMemberEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class RoleMemberEventContext : JsonSerializerContext;