using System.Text.Json.Serialization;

namespace Luski.Shared.PublicServers.V1.Shared;

public class ServerData
{
    [JsonInclude]
    [JsonPropertyName("address")]
    public string DomainAndPort = default!;
    [JsonInclude]
    [JsonPropertyName("secure")]
    public bool Secure;
}

[JsonSerializable(typeof(ServerData))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class ServerDataContext : JsonSerializerContext;