using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.Shared;

public class ServerEvent
{
    [JsonInclude]
    [JsonPropertyName("type")]
    public DataType Type { get; set; }

    [JsonInclude]
    [JsonPropertyName("data")]
    public object Data { get; set; } = default!;
}

[JsonSerializable(typeof(ServerEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class ServerEventContext : JsonSerializerContext;