using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.Shared.PublicServers.V1.Shared;

public class StatusEvent : IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long User { get; set; }
    [JsonInclude]
    [JsonPropertyName("before")]
    public UserStatus Before { get; set; }
    [JsonInclude]
    [JsonPropertyName("after")]
    public UserStatus After { get; set; }
}

[JsonSerializable(typeof(StatusEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
public partial class StatusEventContext : JsonSerializerContext;